<?php
namespace Teknisa\CMP\Controllers;

//use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
//use Zeedhi\Framework\DTO\Exception;
use Zeedhi\Framework\DTO\Response\Error;
//use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\CMP\Util\CmpUtilities;

class CentralComprasController {

    protected $cmpUtilities;

    public function __construct(CmpUtilities $cmpUtilities) {
        $this->cmpUtilities = $cmpUtilities;
    }
    
	public function getCdFilCentCmp(DTO\Request $request, DTO\Response $response) {
        try {
            $centralDeCompras = $this->cmpUtilities->getCentralCompras();
            
            if(!$centralDeCompras) {
                throw new \Exception('CDFILCENTCMP_NOT_REGISTERED');
            }
            
            $response->addDataSet(new DataSet("data", $centralDeCompras));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}