<?php
namespace Teknisa\CMP\Modules\Fornecimento\Modules\AutorizacaoFornecimento\Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\CMP\Util\Attachment;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\Libs\Util\DateUtil;

class Cmp07600AlteracaoAprovacaoAfControllerReport extends \Zeedhi\Framework\Controller\Report {
    protected $qr2Strategy;
    protected $stNomeRel;
    protected $birtStrategy;
    protected $globalReports = [];
    
    public function __construct($reportService, $qr2Strategy, $birtStrategy) {
        $this->reportService = $reportService;
        $this->qr2Strategy   = $qr2Strategy;
        $this->birtStrategy  = $birtStrategy;
    }
    
    protected $reportMapping = array(
        'padraoEnvioAF' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
                array (
                    'CDFILIAL'       => 'P_CDFILIAL',
                    'NRAUTOFORN'     => 'P_NRAUTOFORN',
                    'CDFILLANC'      => 'P_CDFILLANC',
                    'IMPRIMEOBS'     => 'P_IDEXIBEOBSFIL',
                    'IMPRIMEOBSPROD' => 'P_IMPRIMEOBSPROD',
                    'NRORG'          => 'NRORG',
                ),
            ),
    );
    
    public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
        $row = $request->getRow();
        
        $this->globalReports[] = $report;
    }
    
    public function returnAFReport($row) {
        $localResponse = new DTO\Response();
        
        $row['reportLabel']    = 'padraoEnvioAF';
        $row['__report_name']  = 'padraoEnvioAF';
        $row['IMPRIMEOBS']     = 'S';
        $row['IMPRIMEOBSPROD'] = 'S';
        
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        
        parent::createRemoteReport(new DTO\Request\Row(new DTO\Row($row), "", "", ""), $localResponse);
        
        return $this->globalReports[0];
    }
}