<?php
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 31/07/13
 * Time: 19:31
 * To change this template use File | Settings | File Templates.
 */

namespace Folha\Logic\Cadastros\Vinculo;


class Movimentacao {

    const SINDICATO = 10;

    /** @var $movimentacao \GpemovimentacaoEntity */
    private $movimentacao;
    private $nrorg;

    public function __construct($nrorg) {
        $this->nrorg = $nrorg;
    }

    public function nova($nrvinculom, $nrTipoTransferencia, $dtInicioMovimento, $nrEstruturam, $nrTipoEstrutura,
                         $nrTipoMovimento, $nrMotivoTransferencia, $observacao = null)
    {
        $this->movimentacao = new \GpemovimentacaoEntity();
        $this->movimentacao->setNrorg($this->nrorg);
        $this->movimentacao->setNrvinculom($nrvinculom);
        $this->movimentacao->setNrtipotransfer($nrTipoTransferencia);
        $this->movimentacao->setDtinimoviment($dtInicioMovimento);
        $this->movimentacao->setNrestruturam($nrEstruturam);
        $this->movimentacao->setNrtipoestrutura($nrTipoEstrutura);
        $this->movimentacao->setNrtpmovtransfm($nrTipoMovimento);
        $this->movimentacao->setNrmotivotransf($nrMotivoTransferencia);
        $this->movimentacao->setDsobservacao($observacao);

        return $this->movimentacao->persist();
    }

    /**
     * @return \GpemovimentacaoEntity
     */
    public function getMovimentacao()
    {
        return $this->movimentacao;
    }

    public function afterSave($nrorg, $nrvinculom, $nrestruturam, $nrtipoestrutura){

        $competencia = \FPA::getUltimoDiaMes();
        $nrestrutlegal = \FPA::getTipoEstruturaLegalOrg();
        $nrestrutgeren = \FPA::getTipoEstruturaGerencialOrg();

        /** @var $gpevinculom \Folha\Entities\GpeVinculom */
        $gpevinculom = \Folha\Entities\GpeVinculom::findOneByNrvinculomAndNrorg($nrvinculom, $nrorg);

        /** @var $gpevinculoh \Folha\Entities\GpeVinculoh */
        $gpevinculoh = $gpevinculom->retornaUltimoHistoricoCompetencia($competencia);

        if(($nrtipoestrutura == $nrestrutgeren) && ($nrtipoestrutura == $nrestrutlegal)){

            $gpevinculoh->setNrestrutlegal($nrestruturam);
            $gpevinculoh->setNrestrutgeren($nrestruturam);

        }else{
            switch ($nrtipoestrutura){

                case $nrestrutlegal:

                    $gpevinculoh->setNrestrutlegal($nrestruturam);

                    break;

                case $nrestrutgeren:

                    $gpevinculoh->setNrestrutgeren($nrestruturam);

                    break;

                case self::SINDICATO:

                    $gpevinculoh->setNrestrutsind($nrestruturam);

                    break;
            }
        }

            $gpevinculoh->persist();

            \Setforms2\Shared\Registry::getEntityManager()->flush();

    }

    /**
     * Limpa a referencia de estrutura no vinculo historico de acordo com o tipo de estrutura deletada.
     *
     * @param $nrorg
     * @param $nrvinculom
     * @param $nrtipoestrutura
     *
     * leonardocarvalho - 22/08/2014
     * att gabrielcapanema - 12/05/2014
     */
    public function beforeDelete($nrorg, $nrvinculom, $nrtipoestrutura){
        $competencia = \FPA::getUltimoDiaMes();
        $nrestrutlegal = \FPA::getTipoEstruturaLegalOrg();
        $nrestrutgeren = \FPA::getTipoEstruturaGerencialOrg();
        $nrmovimentacaoold = tk_get_field_value('NRMOVIMENTACAO');

        $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
        $connection->beginTransaction();



        /** @var $gpevinculom \Folha\Entities\GpeVinculom */
        $gpevinculom = \Folha\Entities\GpeVinculom::findOneByNrvinculomAndNrorg($nrvinculom, $nrorg);

        /** @var $gpemovimentacao \Folha\Entities\GpeMovimentacao */
        $gpemovimentacaoold = \Folha\Entities\GpeMovimentacao::findOneByNrvinculomAndNrorgAndNrmovimentacao($nrvinculom, $nrorg, $nrmovimentacaoold);
        $gpemovimentacaoold->delete();
        \Setforms2\Shared\Registry::getEntityManager()->flush();
        $connection->commit();
        $connection->beginTransaction();
        $gpemovimentacao = \Gpemovimentacao::getMovimentacao($nrorg, $nrtipoestrutura, $nrvinculom);
        /** @var $gpevinculoh \Folha\Entities\GpeVinculoh */
        $gpevinculoh = $gpevinculom->retornaUltimoHistoricoCompetencia($competencia);


        switch ($nrtipoestrutura){

            case $nrestrutlegal:
                if(is_object($gpemovimentacao)){
                    $gpevinculoh->setNrestrutlegal($gpemovimentacao->getNrestruturam());
                }else {
                    $gpevinculoh->setNrestrutlegal(null);
                }

                break;

            case $nrestrutgeren:

                if(is_object($gpemovimentacao)){
                    $gpevinculoh->setNrestrutgeren($gpemovimentacao->getNrestruturam());
                }else {
                    $gpevinculoh->setNrestrutgeren(null);
                }

                break;

            case self::SINDICATO:

                if(is_object($gpemovimentacao)){
                    $gpevinculoh->setNrestrutsind($gpemovimentacao->getNrestruturam());
                }else {
                    $gpevinculoh->setNrestrutsind(null);
                }

                break;
        }


        $gpevinculoh->persist();
        $connection->commit();
        \Setforms2\Shared\Registry::getEntityManager()->flush();

    }

}