/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TURNO                                                     */
/* Tabela : TURNO                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 16/09/2009 - Vincius Soares Rosa                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TURNO
BEFORE INSERT OR UPDATE OR DELETE
ON TURNO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTURN := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NRTURNO,0)     <> NVL(:NEW.NRTURNO,0))     OR
         (NVL(:OLD.DSTURNO,0)   <> NVL(:NEW.DSTURNO,0))   OR
         (NVL(:OLD.HRFIMTURNO,0) <> NVL(:NEW.HRFIMTURNO,0)) OR
         (NVL(:OLD.HRINITURNO,0) <> NVL(:NEW.HRINITURNO,0)) OR
         (NVL(:OLD.SGTURNO,0) <> NVL(:NEW.SGTURNO,0)) OR
         (NVL(:OLD.HRINIDECOL,0) <> NVL(:NEW.HRINIDECOL,0)) OR
         (NVL(:OLD.HRFINDECOL,0) <> NVL(:NEW.HRFINDECOL,0)) OR
         (NVL(:OLD.IDTIPOTURNO,0) <> NVL(:NEW.IDTIPOTURNO,0))THEN
         :NEW.DTULTATUTURN := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TURNO', '', 'NRTURNO='||:OLD.NRTURNO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TURNO MODIFY DTULTATUTURN DEFAULT SYSDATE
/