CREATE TABLE GRSPARAMFORN
(
  CDFORNECED VARCHAR2(21) NOT NULL,
  VRLIMPESOENTRE FLOAT,
  QTLIMFORNECDIA FLOAT,
  SGUNIDADE VARCHAR2(10),
  CONSTRAINT PK_GRS_CDFORNECED PRIMARY KEY (CDFORNECED)
)

/
ALTER TABLE GRSPARAMFORN
    ADD CONSTRAINT FK_GRS_CDFORNECED FOREIGN KEY  (CDFORNECED)
       REFERENCES FORNECEDOR (CDFORNECED)
/
CREATE INDEX GRS_SGUNIDADE_FK ON GRSPARAMFORN (SGUNIDADE ASC)
/
 CREATE TABLE GRSPARAMFORNOL
(
  CDFORNOL VARCHAR2(21) NOT NULL,
  CDFORNECED VARCHAR2(21) NOT NULL,
  IDTPIJUFORNOL                VARCHAR2(1)            not null
        constraint CKC_IDTPIJUFORNOL check (IDTPIJUFORNOL in ('F','J','I','O')),
  NRINSJUFORNOL        VARCHAR2(20)           not null,   
  NMRAZSOCFORNOL VARCHAR2(40),
  NMFANTFORNOL VARCHAR2(40),
  HRENTRFORNOL VARCHAR2(4) ,
  IDDOMFORNOL        CHAR(1)                null    
        constraint CKC_IDDOMFORNOL check (
            IDDOMFORNOL is null or (IDDOMFORNOL in ('S','N'))),
  IDSEGFORNOL        CHAR(1)                null    
        constraint CKC_IDSEGFORNOL check (
            IDSEGFORNOL is null or (IDSEGFORNOL in ('S','N'))),
  IDTERFORNOL        CHAR(1)                null    
        constraint CKC_IDTERFORNOL check (
            IDTERFORNOL is null or (IDTERFORNOL in ('S','N'))),
  IDQUAFORNOL        CHAR(1)                null    
        constraint CKC_IDQUAFORNOL check (
            IDQUAFORNOL is null or (IDQUAFORNOL in ('S','N'))),
  IDQUIFORNOL        CHAR(1)                null    
        constraint CKC_IDQUIFORNOL check (
            IDQUIFORNOL is null or (IDQUIFORNOL in ('S','N'))),
  IDSEXFORNOL        CHAR(1)                null    
        constraint CKC_IDSEXFORNOL check (
            IDSEXFORNOL is null or (IDSEXFORNOL in ('S','N'))),
  IDSABFORNOL        CHAR(1)                null    
        constraint CKC_IDSABFORNOL check (
            IDSABFORNOL is null or (IDSABFORNOL in ('S','N'))),
  IDDIANUTILOL       VARCHAR2(1)     default 'N' not null
        constraint CKC_IDDIANUTILOL check (IDDIANUTILOL in ('S','N')),
  CONSTRAINT PK_GRS_CDFORNOL PRIMARY KEY (CDFORNOL, CDFORNECED)
) 
/

ALTER TABLE GRSPARAMFORNOL ADD CONSTRAINT FK_GRS_CDFORNOL FOREIGN KEY (CDFORNECED)
REFERENCES GRSPARAMFORN (CDFORNECED)
/
CREATE TABLE GRSCOLEPRFORNOL
(NRCOLEPRFORNOL      VARCHAR2(10)           not null,
 CDFORNECED          VARCHAR2(21)           not null, 
 DTCOLEPRFORNOL          DATE                   not null,
 DTINIVALFORNOL         DATE                   null    ,
 DTFINVALFORNOL         DATE                   null    ,
 CDOPERADOR          VARCHAR2(12)           not null, 
 constraint PK_GRSCOLEPRFORNOL primary key (NRCOLEPRFORNOL)
)
/
alter table GRSCOLEPRFORNOL
    add constraint FK_GRSCOLEPRFORNOL_FORN foreign key  (CDFORNECED)
       references FORNECEDOR (CDFORNECED)
/
alter table GRSCOLEPRFORNOL
    add constraint FK_GRSCOLEPRFORNOL_OPER foreign key  (CDOPERADOR)
       references OPERADOR (CDOPERADOR)
/
create index GRSCOLEPRFORNOL_01 on GRSCOLEPRFORNOL (CDFORNECED, DTINIVALFORNOL DESC,  DTFINVALFORNOL DESC)
/
CREATE TABLE GRSITMCOLFORNOL(
    NRCOLEPRFORNOL      VARCHAR2(10)           not null,
    CDFORNOL            VARCHAR2(21)           not null,
    CDFORNECED          VARCHAR2(21)           NOT NULL,
    CDPRODUTO           VARCHAR2(10)           not null,
    CDMARCA             VARCHAR2(5)            not null,
    DTINVAFORNOL         DATE                  not null,
    DTFIVAFORNOL         DATE                  not null,
    VRPRECUNIITM        FLOAT                  null,
    QTDISPOFORNOL       FLOAT                  null,
    constraint PK_GRSITMCOLFORNOL primary key (NRCOLEPRFORNOL, CDFORNOL, CDFORNECED, CDPRODUTO, CDMARCA)
)
/
alter table GRSITMCOLFORNOL
    add constraint FK_GRSITMCOLFORNOL_COLET foreign key  (NRCOLEPRFORNOL)
       references GRSCOLEPRFORNOL (NRCOLEPRFORNOL)
/
alter table GRSITMCOLFORNOL
    add constraint FK_GRSITMCOLFORNOL_PARAM foreign key  (CDFORNOL, CDFORNECED)
       references GRSPARAMFORNOL (CDFORNOL, CDFORNECED)
/
alter table GRSITMCOLFORNOL
    add constraint FK_GRSITMCOLFORNOL_PROD foreign key  (CDPRODUTO)
       references PRODUTO (CDPRODUTO)
/
alter table GRSITMCOLFORNOL
    add constraint FK_GRSITMCOLFORNOL_MAR foreign key  (CDMARCA)
       references MARCA (CDMARCA)
/
CREATE TABLE GRSAGENDAOL(
    NRAGENDAOL       VARCHAR2(10)              not null,
    CDFORNECED       VARCHAR2(21)              not null,
    DTINIVAGENDAOL   DATE                      not null,
    DTFINVAGENDAOL   DATE                      not null,
    CDPRODINIOL      VARCHAR2(20)              not null,
    CDPRODFINOL      VARCHAR2(20)              not null,
    DTAGENDAOL       DATE                      not null,
    CDOPERADOR       VARCHAR2(12)              not null,
    IDAFPERIODO      VARCHAR2(1)               default 'N' not null
        constraint CKC_IDAFPERIODO check (IDAFPERIODO in ('S','N')),
    VRACRESCIMO      FLOAT                     null,
    DSLISTAMES       VARCHAR2(200)             null,
    constraint PK_GRSAGENDAOL primary key (NRAGENDAOL, CDFORNECED)
)
/

alter table GRSAGENDAOL
    add constraint FK_GRSAGENDAOL_FORN foreign key  (CDFORNECED)
       references FORNECEDOR (CDFORNECED)
/
alter table GRSAGENDAOL
    add constraint FK_GRSAGENDAOL_OP foreign key  (CDOPERADOR)
       references OPERADOR(CDOPERADOR)
/
CREATE TABLE GRSITEMAGENDAOL(
    NRAGENDAOL       VARCHAR2(10)              not null,
    CDFORNECED       VARCHAR2(21)              not null,
    CDFORNOL         VARCHAR2(21)              not null,
    CDPRODUTO        VARCHAR2(10)              not null,
    CDMARCA          VARCHAR2(5)               not null,
    DTENTREGAGENDA   DATE                      not null,
    QTESTOQFORNOL    FLOAT                     null,
    VRPREUNIAGENDA   FLOAT                     null,
    QTPREVITMFORNOL  FLOAT                     null,
    QTPROGITMFORNOL  FLOAT                     null,
    QTRECEEITFORNOL  FLOAT                     null,
    IDITEMAGENDADO   VARCHAR2(1)               null
        constraint CKC_IDITEMAGENDADO check (IDITEMAGENDADO is null or (IDITEMAGENDADO in ('N', 'S'))),
    DSENTREGAGENDA   VARCHAR2(150)             null,
    IDENTREGAGENDA   VARCHAR2(1)               default 'N' not null
        constraint CKC_IDENTREGAGENDA check (IDENTREGAGENDA in ('S','N')),
    IDAJUSTADO       VARCHAR2(1)               default 'N' not null,
    QTDISPOFORNOL    FLOAT                     null,
    constraint PK_GRSITEMAGENDAOL primary key (NRAGENDAOL, CDFORNECED, CDFORNOL, CDPRODUTO, CDMARCA, DTENTREGAGENDA)
    )
/
alter table GRSITEMAGENDAOL
    add constraint FK_GRSITEMAGENDAOL_AG foreign key  (NRAGENDAOL, CDFORNECED)
       references GRSAGENDAOL (NRAGENDAOL, CDFORNECED)
/
alter table GRSITEMAGENDAOL
    add constraint FK_GRSITEMAGENDAOL_PARAM foreign key  (CDFORNECED, CDFORNOL)
       references GRSPARAMFORNOL (CDFORNECED, CDFORNOL)
/
alter table GRSITEMAGENDAOL
    add constraint FK_GRSITEMAGENDAOL_PROD foreign key  (CDPRODUTO)
       references PRODUTO (CDPRODUTO)
/
alter table GRSITEMAGENDAOL
    add constraint FK_GRSITEMAGENDAOL_MARC foreign key  (CDMARCA)
       references MARCA (CDMARCA)
/
CREATE TABLE POSESTOL(
   CDFORNECED          VARCHAR2(21)           not null,
   CDPRODUTO           VARCHAR2(10)           not null,
   DTPOSESTOL          DATE                   not null,
   CDMARCA             VARCHAR2(5)            null, /*Verificar se o campo  not null e constraint de marca*/
   QTPOSESTOL          FLOAT                  null,
   constraint PK_POSESTOL primary key (CDFORNECED, CDPRODUTO, DTPOSESTOL))
/
alter table POSESTOL
    add constraint FK_CDFORNESTOL foreign key  (CDFORNECED)
       references FORNECEDOR (CDFORNECED)
/
alter table POSESTOL
    add constraint FK_CDPRODESTOL foreign key  (CDPRODUTO)
       references PRODUTO (CDPRODUTO)
/