function CMP03909ImportacaoProdutoFornecedorController(CMP03909ImportacaoProdutoFornecedorService, Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller, metaDataFactory, $http, General, Utilities, ScreenService, templateManager, MessageService, ZHPromise, maskEngine, ZhUtil) {
    
    var ServiceProdutoFornecedor = CMP03909ImportacaoProdutoFornecedorService;

    /**********
     * Filtro *
     **********/
    
    this.onEnterOnceImportacaoProdutoFornecedor = function(widget) {
        const filterRow = {
            FORNECEDOR: '',
            COMPRADOR: '',
            CDFILDEST: '',
            CARREGARPRECOLISTA: 'N',
            NMTIPOCUSTO: '',
            NMPRODINI: '',
            NMPRODFIN: '',
            NMAUTOFORN: '',
            CARREGARITEMINCONSISTENTE: 'N'
        };
        
        widget.getField('DT_ENTREGA').defaultValue.start = moment().format('DD/MM/YYYY');
        widget.getField('DT_ENTREGA').defaultValue.end   = moment().format('DD/MM/YYYY');
        
        Utilities.startFilter(widget, filterRow);
    };
    
    function skipZeedhiFilterApply(args) {
        args.e.preference.CUSTOM_FILTER_ROW = {};
    }
    
    this.beforeFilterApply = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;
        const widgetGrid = templateManager.container.getWidget('cmp03909_grid');
        
        skipZeedhiFilterApply(args);
        
        // if(!widget.SENHA_GERENTE) {
        //     return ScreenService.showMessage("Senha inválida!");
        // }
        
        if(filterRow.CDPRODFIN !== "" && filterRow.CDPRODFIN !== undefined){
            filterRow.CDPRODFIN.padEnd(20,'Z');
        }
        
        if(filterRow.NMAUTOFORN == ""){
            widgetGrid.dataSourceFilter = [
                {
                    name: 'P_COMPRADOR',
                    operator: '=',
                    value: filterRow.CDOPERADOR,
                },
                {
                    name: 'P_CDFILDEST',
                    operator: '=',
                    value: filterRow.CDFILDEST,
                },
                {
                    name: 'P_CARREGARPRECOLISTA',
                    operator: '=',
                    value: filterRow.CARREGARPRECOLISTA,
                },
                {
                    name: 'P_NMTIPOCUSTO',
                    operator: '=',
                    value: filterRow.NMTIPOCUSTO,
                },
                {
                    name: 'P_NMPRODINI',
                    operator: '=',
                    value: filterRow.CDPRODINI,
                },
                {
                    name: 'P_NMPRODFIN',
                    operator: '=',
                    value: filterRow.CDPRODFIN,
                },
                {
                    name: 'P_DT_ENTREGA',
                    operator: '=',
                    value: filterRow.DT_ENTREGA,
                },
                {
                    name: 'NRORG',
                    operator: '=',
                    value: getLocalVar('NRORG'),
                }
            ];
        } else {
            widgetGrid.dataSourceFilter = [
                {
                    name: 'P_NRAUTOFORN',
                    operator: '=',
                    value: filterRow.NRAUTOFORN,
                },
                {
                    name: 'P_CARREGARITEMINCONSISTENTE',
                    operator: '=',
                    value: filterRow.CARREGARITEMINCONSISTENTE,
                }
            ];
        }
        
        ServiceProdutoFornecedor.procedureIMPORT_PRODFORNCOMP(filterRow).then(function(response) {
            if(response.data == true){
                MessageService.confirmMessageByCode("QUESTION_VERIFICAR_INCONSISTENCIA_IMPORTACAO_AF", null, Constants.confirmationMessage).then(function(success) {
                    ScreenService.openPopup(widgetGrid.container.getWidget('gridInconsistenciaimportacaoAF'));
                }, function(error) {
                    ScreenService.errorNotification(error, 'ERROR');
                });
            }
        }).catch(function(error) {
            ScreenService.showMessage(error.data.error);
        });

        
    };
    
    this.afterFilterApply = function(widget) {
        widget.floatingControl.refreshAction = true;
        if (widget.dataSource.data.length) {
            if(widget.dataSource.data[0].CDMARCA == null){
                MessageService.showMessageByCode("MARCA_NOT_REGISTERED", null, Constants.errorMessage).then(function(){
                    widget.dataSource.data = [];	
                });
            }
        }
    };
    
    this.onChangeTipoCusto = function(fieldCarregaPrecoLista) {
        const widget = fieldCarregaPrecoLista.widget;
        const fieldTipoCusto = widget.getField('NMTIPOCUSTO');
        ScreenService.showLoader();
        if (fieldCarregaPrecoLista.checked == true) {
            fieldTipoCusto.clearValue();
            fieldTipoCusto.value = "";
            fieldTipoCusto.readOnly = true;
            fieldTipoCusto.validations = {};
        } else {
            fieldTipoCusto.clearValue();
            fieldTipoCusto.value = "";
            fieldTipoCusto.readOnly = false;
            fieldTipoCusto.validations = {"required": true};
        }
        widget.reload();
        widget.redraw();
        ScreenService.hideLoader();
    };
    
    this.onChangeFields = function(fieldNumero) {
        const widget = fieldNumero.widget;
        if (fieldNumero.value() !== "") {
            widget.getField('FORNECEDOR').validations = {};
            widget.getField('COMPRADOR').validations = {};
            widget.getField('DT_ENTREGA').validations = {};
            widget.getField('NMTIPOCUSTO').validations = {};
            widget.getField('FORNECEDOR').clearValue();
            widget.getField('COMPRADOR').clearValue();
            widget.getField('CDFILDEST').clearValue();
            widget.getField('DT_ENTREGA').clearValue();
            widget.getField('NMTIPOCUSTO').clearValue();
            widget.getField('NMPRODINI').clearValue();
            widget.getField('NMPRODFIN').clearValue();
            widget.getField('FORNECEDOR').readOnly = true;
            widget.getField('COMPRADOR').readOnly = true;
            widget.getField('CDFILDEST').readOnly = true;
            widget.getField('DT_ENTREGA').readOnly = true;
            widget.getField('CARREGARPRECOLISTA').readOnly = true;
            widget.getField('NMTIPOCUSTO').readOnly = true;
            widget.getField('NMPRODINI').readOnly = true;
            widget.getField('NMPRODFIN').readOnly = true;
            widget.getField('CARREGARITEMINCONSISTENTE').readOnly = false;
            this.setCheckboxValue();
        } else {
            widget.getField('FORNECEDOR').validations = {"required": true};
            widget.getField('COMPRADOR').validations = {"required": true};
            widget.getField('DT_ENTREGA').validations = {"requiredInterval": {}};
            widget.getField('NMTIPOCUSTO').validations = {"required": true};
            widget.getField('FORNECEDOR').clearValue();
            widget.getField('COMPRADOR').clearValue();
            widget.getField('CDFILDEST').clearValue();
            widget.getField('NMTIPOCUSTO').clearValue();
            widget.getField('NMPRODINI').clearValue();
            widget.getField('NMPRODFIN').clearValue();
            widget.getField('FORNECEDOR').readOnly = false;
            widget.getField('COMPRADOR').readOnly = false;
            widget.getField('CDFILDEST').readOnly = false;
            widget.getField('DT_ENTREGA').readOnly = false;
            widget.getField('CARREGARPRECOLISTA').readOnly = false;
            widget.getField('NMTIPOCUSTO').readOnly = false;
            widget.getField('NMPRODINI').readOnly = false;
            widget.getField('NMPRODFIN').readOnly = false;
            widget.getField('CARREGARITEMINCONSISTENTE').readOnly = true;
            this.setFieldDTENTREGA();
            this.setCheckboxValue();
        }
        widget.reload();
        widget.redraw();
        ScreenService.hideLoader();
    };
    
    this.setFieldDTENTREGA = function(){
        const widgetCMP03909 = templateManager.container.getActiveWidget();
        widgetCMP03909.getField('DT_ENTREGA').value().start = moment().format('DD/MM/YYYY');
        widgetCMP03909.getField('DT_ENTREGA').value().end = moment().format('DD/MM/YYYY');
        widgetCMP03909.getField('DT_ENTREGA').value().formattedStart = moment().format('DD/MM/YYYY');
        widgetCMP03909.getField('DT_ENTREGA').value().formattedEnd = moment().format('DD/MM/YYYY');
    };
    
    this.setCheckboxValue = function(){
        const widgetCMP03909 = templateManager.container.getActiveWidget();
        widgetCMP03909.getField('CARREGARITEMINCONSISTENTE').setValue("N");
		widgetCMP03909.getField('CARREGARPRECOLISTA').setValue("N");
    };
    
    this.filterProdIni = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodIniIsSet = row.CDPRODINI ? true : false;
		
		if(!prodIniIsSet) {
			widget.currentRow.NMPRODFIN = '';
			widget.currentRow.CDPRODFIN = '';
		}
        this.checkProductRange(args.owner.field);
	};
	
	this.filterProdFin = function(args) {
		var widget = args.owner.field.widget;
		var row = widget.currentRow;
		var prodFinIsSet = row.CDPRODFIN ? true : false;
		var prodIniIsSet = row.CDPRODINI ? true : false;
		
		if (prodFinIsSet) {
			if (row.CDPRODINI > row.CDPRODFIN) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		} else if(!prodIniIsSet) {
            widget.currentRow.NMPRODFIN = null;
            widget.currentRow.CDPRODFIN = null;
		}
		
		this.checkProductRange(args.owner.field);
	};
	
	this.checkProductRange = function(field) {
	   var currentRow = field.widget.currentRow;

		if (currentRow.CDPRODINI && currentRow.CDPRODFIN) {
			var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

			if (!this.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('CDPICTPROD'))) {
				currentRow[field.outData[field.descriptionField]] = null;
				currentRow[field.outData[field.valueField]] = null;

                field.widget.getField('NMPRODINI').clearValue();
                field.widget.getField('NMPRODFIN').clearValue();
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
			}
		}
	};
	
	this.comparaPratoProduto = function(pinicial, pfinal, mascara) {
        var mask = {
          type: "fix",
          params: {
              mask: mascara
          }
        };
        pinicial = Util.applyMask(pinicial, mask, maskEngine, ZhUtil).split('.');
        pfinal = Util.applyMask(pfinal, mask, maskEngine, ZhUtil).split('.');
        var nvinicial = pinicial.length;
        var nvfinal = pfinal.length;
        var resultado = true;
        if(nvinicial != nvfinal) {
            if(nvinicial > nvfinal) {
                resultado = false;
            }
        } else {
            var i = 0;
            do {
                if(pinicial[i] > pfinal[i]) {
                    resultado = false;
                }
                i++;
            }
            while (i<pinicial.length && resultado);
        }
        return resultado;
    };
    
    this.verifyDateEntrega = function(field) {
        const dt_emtrega = field.value().start;
        if(moment(dt_emtrega).isBefore(moment().format("DD/MM/YYYY"))) {
            MessageService.showMessageByCode("DTPROGENTAF>DTATUAL", null, Constants.alertMessage);
        }
    };
    
    /********
     * Grid *
     ********/  
    this.voltarParaLancamentoAF = function() {
        $http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_lancamento_autorizacao_de_fornecimento.json').then(function(response) {
            const containerLancamentoAF = this.containerFactory(response.data);
            
            Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller.containerAF = containerLancamentoAF;
            templateManager.container = containerLancamentoAF;
        }.bind(metaDataFactory));
    };
     
    this.importarParaAutorizacaoFornecimento = function(widget) {
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const unidadeDestino = {
            codigo: filterRow.CDFILIAL,
            nome: filterRow.NMFILIAL,
        };
        
        if(verificaDtEntregaPorFornecedor(filterRow)) {
            $http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_lancamento_autorizacao_de_fornecimento.json').then(function(response) {
                const containerLancamentoAF = this.containerFactory(response.data);
                
                Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller.setContainer(containerLancamentoAF);
                
                const filtro     = containerLancamentoAF.getWidget('filtro');
                const qtdVolume  = containerLancamentoAF.getWidget('produtos').getField('QTVOLUITEMAF').isVisible;
                const inconsAF   = containerLancamentoAF.getWidget('inconsistencias').getAction('ignorarInconsistencia').isVisible;
                
        		$http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_adicao_autorizacao_de_fornecimento.json').then(function(result) {
        			const containerAdicaoAF = this.containerFactory(result.data);
        			
        			templateManager.container = containerAdicaoAF;
        			
        			const tabAdicao = templateManager.container.getWidget('tab_adicao');
        			
        			const itens = widget.getCheckedRows().map(row => {
        			    row.QTESTOQUE = General.valueToFloat(row.QTESTOQUE);
        			    row.QTSOLIPROD = General.valueToFloat(row.QTSOLIPROD);
        			    row.VRCUSTO = General.valueToFloat(row.VRCUSTO);
        			    row.IDITMIPORT = true;
        			    
        			    return row;
        			});
        			
        			containerAdicaoAF.isImportacao = true;
        			containerAdicaoAF.dadosImportacao = {
        			    NMRAZSOCFORN: filterRow.NMRAZSOCFORN,
                        CDFORNECED: filterRow.CDFORNECED,
                        IDGERAFDTENT: filterRow.IDGERAFDTENT,
                        CDOPERADOR: filterRow.CDOPERADOR,
                        NMOPERADOR: filterRow.NMOPERADOR,
                        itens
        			};
        			
        			Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller.onEnterAdicao({
        			    widget: tabAdicao,
        			    filtro,
        			    qtdVolume,
        			    unidadeDestino,
        			    inconsAF,
        			    isOnEnterEvent: true,
        			});
        		}.bind(this), function(error) {
        			throw error;
        		});
            }.bind(metaDataFactory));
        }
    };
    
    this.verificaCusto = function(args) {
        const widgetGrid = templateManager.container.getWidget('cmp03909_grid');
        
        if(widgetGrid.editing) {
        	args.e.preventDefault();
        }
        
        if(parseFloat(args.selectedRow.QTSOLIPROD) == 0){
            MessageService.showMessageByCode("INFORMAR_QTDE", null, Constants.errorMessage);
            args.e.preventDefault();   
        }
        
        if(parseFloat(args.selectedRow.VRCUSTO) == 0){
            MessageService.showMessageByCode("INFORMAR_CUSTO", null, Constants.errorMessage);
            args.e.preventDefault();   
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CMP03909ImportacaoProdutoFornecedorController', CMP03909ImportacaoProdutoFornecedorController);
});