function Cmp04502_EmissaoDaListaDePrecos_Controller(General, ScreenService, localStorageEngine, MessageService) {

    this.onEnter = function(owner){
        setProdutoDefault(owner);
        
        owner.currentRow.DT_INTERVAL.start = moment().format('DD/MM/YYYY');
        owner.currentRow.DT_INTERVAL.end = moment().format('DD/MM/YYYY'); 
    };
    
    function setProdutoDefault(widget){
        const filter = [
            {
                name: "NRORG",
                operator: "=",
                value: getLocalVar('NRORG')
            }    
        ];
        
        General.callRestEngine("cmp_fornecimento_listaPreco#/cmp04502_emissao_da_lista_de_precos_produto", "FilterData", filter).then(function(callback) {
            const { NMMIN, NMMAX, CDMIN, CDMAX } = callback.dataset.cmp04502_emissao_da_lista_de_precos_produto[0];
            
            widget.currentRow.NMPRODINI = NMMIN;
            widget.currentRow.NMPRODFIN = NMMAX;
            widget.currentRow.CDPRODINI = CDMIN;
            widget.currentRow.CDPRODFIN = CDMAX;
        });
    }

    this.validaProduto = function(prodInicial, prodFinal) {

        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }
        
        return true;
    };
    
    function formataParametrosRelatorio(currentRow) {
        currentRow.COMPRADOR   = concatArrayForParams(currentRow.L_COMPRADOR);
        currentRow.FORNECEDOR  = concatArrayForParams(currentRow.L_FORNECEDOR);
        currentRow.P_CDPRODFIN = validaProdutoFinal(currentRow);
        currentRow.COMPRADOR1  = currentRow.COMPRADOR;
        currentRow.FORNECEDOR1 = currentRow.FORNECEDOR;
        currentRow.DTINI       = currentRow.DT_INTERVAL.start;
        currentRow.DTFIM       = currentRow.DT_INTERVAL.end;
    }
    
    this.abreRelatorio = function(widget, currentRow, reportName) {
        formataParametrosRelatorio(currentRow);
        
        General.openReport('cmp_fornecimento_listaPreco#/cmp04502_relatorio', reportName, currentRow);  
    };
    
    this.criaRelatorio = function(widget) {
        const reportName  = widget.currentRow.REPORT_NAME;
        
        if (!widget.isValid()) return;
        
        if (!this.validaProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN)) return;
        
        General.openReportPopup(widget, this.abreRelatorio, [widget, widget.currentRow, reportName]);
    };
    
    /*************
     * Utilities *
     *************/
    
    function concatArrayForParams(arr, defaultValue = 'T') {
       return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue;
    }
    
    function validaProdutoFinal(row) { 
        let prod;
        
        if (row.CDPRODFIN === undefined || row.CDPRODFIN === "") {
            prod = "";
        } else {
            prod = row.CDPRODFIN.padEnd(20,'Z');
        }
        
        return prod;
    }
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp04502_EmissaoDaListaDePrecos_Controller', Cmp04502_EmissaoDaListaDePrecos_Controller);
});